=begin
#ShipEngine API

#ShipEngine's easy-to-use REST API lets you manage all of your shipping needs without worrying about the complexities of different carrier APIs and protocols. We handle all the heavy lifting so you can focus on providing a first-class shipping experience for your customers at the best possible prices.  Each of ShipEngine's features can be used by itself or in conjunction with each other to build powerful shipping functionality into your application or service.  ## Getting Started If you're new to REST APIs then be sure to read our [introduction to REST](https://www.shipengine.com/docs/rest/) to understand the basics. Learn how to [authenticate yourself to ShipEngine](https://www.shipengine.com/docs/auth/), and then use our [sandbox environment](https://www.shipengine.com/docs/sandbox/) to kick the tires and get familiar with our API. If you run into any problems, then be sure to check the [error handling guide](https://www.shipengine.com/docs/errors/) for tips.  Here are some step-by-step **tutorials** to get you started:    - [Learn how to create your first shipping label](https://www.shipengine.com/docs/labels/create-a-label/)   - [Calculate shipping costs and compare rates across carriers](https://www.shipengine.com/docs/rates/)   - [Track packages on-demand or in real time](https://www.shipengine.com/docs/tracking/)   - [Validate mailing addresses anywhere on Earth](https://www.shipengine.com/docs/addresses/validation/)   ## Shipping Labels for Every Major Carrier ShipEngine makes it easy to [create shipping labels for any carrier](https://www.shipengine.com/docs/labels/create-a-label/) and [download them](https://www.shipengine.com/docs/labels/downloading/) in a [variety of file formats](https://www.shipengine.com/docs/labels/formats/). You can even customize labels with your own [messages](https://www.shipengine.com/docs/labels/messages/) and [images](https://www.shipengine.com/docs/labels/branding/).   ## Real-Time Package Tracking With ShipEngine you can [get the current status of a package](https://www.shipengine.com/docs/tracking/) or [subscribe to real-time tracking updates](https://www.shipengine.com/docs/tracking/webhooks/) via webhooks. You can also create [custimized tracking pages](https://www.shipengine.com/docs/tracking/branded-tracking-page/) with your own branding so your customers will always know where their package is.   ## Compare Shipping Costs Across Carriers Make sure you ship as cost-effectively as possible by [comparing rates across carriers](https://www.shipengine.com/docs/rates/get-shipment-rates/) using the ShipEngine Rates API. Or if you don't know the full shipment details yet, then you can [get rate estimates](https://www.shipengine.com/docs/rates/estimate/) with limited address info.   ## Worldwide Address Validation ShipEngine supports [address validation](https://www.shipengine.com/docs/addresses/validation/) for virtually [every country on Earth](https://www.shipengine.com/docs/addresses/validation/countries/), including the United States, Canada, Great Britain, Australia, Germany, France, Norway, Spain, Sweden, Israel, Italy, and over 160 others. 

The version of the OpenAPI document: 1.1.202006302006
Contact: sales@shipengine.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module OpenapiClient
  class InsuranceApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add Funds To Insurance
    # You may need to auto fund your account from time to time. For example, if you don't normally ship items over $100, and may want to add funds to insurance rather than keeping the account funded. 
    # @param add_funds_to_insurance_request_body [AddFundsToInsuranceRequestBody] 
    # @param [Hash] opts the optional parameters
    # @return [AddFundsToInsuranceResponseBody]
    def add_funds_to_insurance(add_funds_to_insurance_request_body, opts = {})
      data, _status_code, _headers = add_funds_to_insurance_with_http_info(add_funds_to_insurance_request_body, opts)
      data
    end

    # Add Funds To Insurance
    # You may need to auto fund your account from time to time. For example, if you don&#39;t normally ship items over $100, and may want to add funds to insurance rather than keeping the account funded. 
    # @param add_funds_to_insurance_request_body [AddFundsToInsuranceRequestBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AddFundsToInsuranceResponseBody, Integer, Hash)>] AddFundsToInsuranceResponseBody data, response status code and response headers
    def add_funds_to_insurance_with_http_info(add_funds_to_insurance_request_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InsuranceApi.add_funds_to_insurance ...'
      end
      # verify the required parameter 'add_funds_to_insurance_request_body' is set
      if @api_client.config.client_side_validation && add_funds_to_insurance_request_body.nil?
        fail ArgumentError, "Missing the required parameter 'add_funds_to_insurance_request_body' when calling InsuranceApi.add_funds_to_insurance"
      end
      # resource path
      local_var_path = '/v1/insurance/shipsurance/add_funds'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(add_funds_to_insurance_request_body) 

      # return_type
      return_type = opts[:return_type] || 'AddFundsToInsuranceResponseBody' 

      # auth_names
      auth_names = opts[:auth_names] || ['api_key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InsuranceApi#add_funds_to_insurance\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Connect a Shipsurance Account
    # Connect a Shipsurance Account
    # @param connect_insurer_request_body [ConnectInsurerRequestBody] 
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def connect_insurer(connect_insurer_request_body, opts = {})
      data, _status_code, _headers = connect_insurer_with_http_info(connect_insurer_request_body, opts)
      data
    end

    # Connect a Shipsurance Account
    # Connect a Shipsurance Account
    # @param connect_insurer_request_body [ConnectInsurerRequestBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def connect_insurer_with_http_info(connect_insurer_request_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InsuranceApi.connect_insurer ...'
      end
      # verify the required parameter 'connect_insurer_request_body' is set
      if @api_client.config.client_side_validation && connect_insurer_request_body.nil?
        fail ArgumentError, "Missing the required parameter 'connect_insurer_request_body' when calling InsuranceApi.connect_insurer"
      end
      # resource path
      local_var_path = '/v1/connections/insurance/shipsurance'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(connect_insurer_request_body) 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || ['api_key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InsuranceApi#connect_insurer\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Disconnect a Shipsurance Account
    # Disconnect a Shipsurance Account
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def disconnect_insurer(opts = {})
      data, _status_code, _headers = disconnect_insurer_with_http_info(opts)
      data
    end

    # Disconnect a Shipsurance Account
    # Disconnect a Shipsurance Account
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def disconnect_insurer_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InsuranceApi.disconnect_insurer ...'
      end
      # resource path
      local_var_path = '/v1/connections/insurance/shipsurance'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || ['api_key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InsuranceApi#disconnect_insurer\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Insurance Funds Balance
    # Retrieve the balance of your Shipsurance account.
    # @param [Hash] opts the optional parameters
    # @return [GetInsuranceBalanceResponseBody]
    def get_insurance_balance(opts = {})
      data, _status_code, _headers = get_insurance_balance_with_http_info(opts)
      data
    end

    # Get Insurance Funds Balance
    # Retrieve the balance of your Shipsurance account.
    # @param [Hash] opts the optional parameters
    # @return [Array<(GetInsuranceBalanceResponseBody, Integer, Hash)>] GetInsuranceBalanceResponseBody data, response status code and response headers
    def get_insurance_balance_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InsuranceApi.get_insurance_balance ...'
      end
      # resource path
      local_var_path = '/v1/insurance/shipsurance/balance'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'GetInsuranceBalanceResponseBody' 

      # auth_names
      auth_names = opts[:auth_names] || ['api_key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InsuranceApi#get_insurance_balance\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
