=begin
#ShipEngine API

#ShipEngine's easy-to-use REST API lets you manage all of your shipping needs without worrying about the complexities of different carrier APIs and protocols. We handle all the heavy lifting so you can focus on providing a first-class shipping experience for your customers at the best possible prices.  Each of ShipEngine's features can be used by itself or in conjunction with each other to build powerful shipping functionality into your application or service.  ## Getting Started If you're new to REST APIs then be sure to read our [introduction to REST](https://www.shipengine.com/docs/rest/) to understand the basics. Learn how to [authenticate yourself to ShipEngine](https://www.shipengine.com/docs/auth/), and then use our [sandbox environment](https://www.shipengine.com/docs/sandbox/) to kick the tires and get familiar with our API. If you run into any problems, then be sure to check the [error handling guide](https://www.shipengine.com/docs/errors/) for tips.  Here are some step-by-step **tutorials** to get you started:    - [Learn how to create your first shipping label](https://www.shipengine.com/docs/labels/create-a-label/)   - [Calculate shipping costs and compare rates across carriers](https://www.shipengine.com/docs/rates/)   - [Track packages on-demand or in real time](https://www.shipengine.com/docs/tracking/)   - [Validate mailing addresses anywhere on Earth](https://www.shipengine.com/docs/addresses/validation/)   ## Shipping Labels for Every Major Carrier ShipEngine makes it easy to [create shipping labels for any carrier](https://www.shipengine.com/docs/labels/create-a-label/) and [download them](https://www.shipengine.com/docs/labels/downloading/) in a [variety of file formats](https://www.shipengine.com/docs/labels/formats/). You can even customize labels with your own [messages](https://www.shipengine.com/docs/labels/messages/) and [images](https://www.shipengine.com/docs/labels/branding/).   ## Real-Time Package Tracking With ShipEngine you can [get the current status of a package](https://www.shipengine.com/docs/tracking/) or [subscribe to real-time tracking updates](https://www.shipengine.com/docs/tracking/webhooks/) via webhooks. You can also create [custimized tracking pages](https://www.shipengine.com/docs/tracking/branded-tracking-page/) with your own branding so your customers will always know where their package is.   ## Compare Shipping Costs Across Carriers Make sure you ship as cost-effectively as possible by [comparing rates across carriers](https://www.shipengine.com/docs/rates/get-shipment-rates/) using the ShipEngine Rates API. Or if you don't know the full shipment details yet, then you can [get rate estimates](https://www.shipengine.com/docs/rates/estimate/) with limited address info.   ## Worldwide Address Validation ShipEngine supports [address validation](https://www.shipengine.com/docs/addresses/validation/) for virtually [every country on Earth](https://www.shipengine.com/docs/addresses/validation/countries/), including the United States, Canada, Great Britain, Australia, Germany, France, Norway, Spain, Sweden, Israel, Italy, and over 160 others. 

The version of the OpenAPI document: 1.1.202006302006
Contact: sales@shipengine.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module OpenapiClient
  class AddressValidationDetailCode
    UNSUPPORTED_COUNTRY = "unsupported_country".freeze
    NON_SUPPORTED_COUNTRY = "non_supported_country".freeze
    MINIMUM_POSTAL_CODE_VERIFICATION_FAILED = "minimum_postal_code_verification_failed".freeze
    STREET_DOES_NOT_MATCH_UNIQUE_STREET_NAME = "street_does_not_match_unique_street_name".freeze
    MULTIPLE_DIRECTIONALS = "multiple_directionals".freeze
    MULTIPLE_MATCHES = "multiple_matches".freeze
    SUITE_NOT_VALID = "suite_not_valid".freeze
    SUITE_MISSING = "suite_missing".freeze
    INCOMPATIBLE_PAIRED_LABELS = "incompatible_paired_labels".freeze
    INVALID_HOUSE_NUMBER = "invalid_house_number".freeze
    MISSING_HOUSE_NUMBER = "missing_house_number".freeze
    INVALID_BOX_NUMBER = "invalid_box_number".freeze
    INVALID_CHARGE_EVENT = "invalid_charge_event".freeze
    MISSING_BOX_NUMBER = "missing_box_number".freeze
    MISSING_CMRA_OR_PRIVATE_MAIL_BOX_NUMBER = "missing_cmra_or_private_mail_box_number".freeze
    SUITE_HAS_NO_SECONDARIES = "suite_has_no_secondaries".freeze
    POSTAL_CODE_CHANGED_OR_ADDED = "postal_code_changed_or_added".freeze
    STATE_PROVINCE_CHANGED_OR_ADDED = "state_province_changed_or_added".freeze
    CITY_LOCALITY_CHANGED_OR_ADDED = "city_locality_changed_or_added".freeze
    URBANIZATION_CHANGED = "urbanization_changed".freeze
    STREET_NAME_SPELLING_CHANGED_OR_ADDED = "street_name_spelling_changed_or_added".freeze
    STREET_NAME_TYPE_CHANGED_OR_ADDED = "street_name_type_changed_or_added".freeze
    STREET_DIRECTION_CHANGED_OR_ADDED = "street_direction_changed_or_added".freeze
    SUITE_TYPE_CHANGED_OR_ADDED = "suite_type_changed_or_added".freeze
    SUITE_UNIT_NUMBER_CHANGED_OR_ADDED = "suite_unit_number_changed_or_added".freeze
    DOUBLE_DEPENDENT_LOCALITY_CHANGED_OR_ADDED = "double_dependent_locality_changed_or_added".freeze
    SUBADMINISTRATIVE_AREA_CHANGED_OR_ADDED = "subadministrative_area_changed_or_added".freeze
    SUBNATIONAL_AREA_CHANGED_OR_ADDED = "subnational_area_changed_or_added".freeze
    PO_BOX_CHANGED_OR_ADDED = "po_box_changed_or_added".freeze
    PREMISE_TYPE_CHANGED_OR_ADDED = "premise_type_changed_or_added".freeze
    HOUSE_NUMBER_CHANGED = "house_number_changed".freeze
    ORGANIZATION_CHANGED_OR_ADDED = "organization_changed_or_added".freeze
    PARTIALLY_VERIFIED_TO_STATE_LEVEL = "partially_verified_to_state_level".freeze
    PARTIALLY_VERIFIED_TO_CITY_LEVEL = "partially_verified_to_city_level".freeze
    PARTIALLY_VERIFIED_TO_STREET_LEVEL = "partially_verified_to_street_level".freeze
    PARTIALLY_VERIFIED_TO_PREMISE_LEVEL = "partially_verified_to_premise_level".freeze
    VERIFIED_TO_STATE_LEVEL = "verified_to_state_level".freeze
    VERIFIED_TO_CITY_LEVEL = "verified_to_city_level".freeze
    VERIFIED_TO_STREET_LEVEL = "verified_to_street_level".freeze
    VERIFIED_TO_PREMISE_LEVEL = "verified_to_premise_level".freeze
    VERIFIED_TO_SUITE_LEVEL = "verified_to_suite_level".freeze
    CODED_TO_STREET_LAVEL = "coded_to_street_lavel".freeze
    CODED_TO_NEIGHBORHOOD_LEVEL = "coded_to_neighborhood_level".freeze
    CODED_TO_COMMUNITY_LEVEL = "coded_to_community_level".freeze
    CODED_TO_STATE_LEVEL = "coded_to_state_level".freeze
    CODED_TO_ROOFTOP_LEVEL = "coded_to_rooftop_level".freeze
    CODED_TO_ROOFTOP_INTERPOLATION_LEVEL = "coded_to_rooftop_interpolation_level".freeze
    NAME_MAX_LENGTH_EXCEEDED = "name_max_length_exceeded".freeze
    PHONE_MAX_LENGTH_EXCEEDED = "phone_max_length_exceeded".freeze
    COMPANY_NAME_MAX_LENGTH_EXCEEDED = "company_name_max_length_exceeded".freeze
    LINE1_MIN_MAX_LENGTH = "line1_min_max_length".freeze
    LINE2_MAX_LENGTH_EXCEEDED = "line2_max_length_exceeded".freeze
    LINE3_MAX_LENGTH_EXCEEDED = "line3_max_length_exceeded".freeze
    CITY_LOCALITY_MAX_LENGTH_EXCEEDED = "city_locality_max_length_exceeded".freeze
    STATE_PROVINCE_MAX_LENGTH_EXCEEDED = "state_province_max_length_exceeded".freeze
    INVALID_POSTAL_CODE = "invalid_postal_code".freeze
    COUNTRY_INVALID_LENGTH = "country_invalid_length".freeze
    ADDRESS_NOT_FOUND = "address_not_found".freeze

    # Builds the enum from string
    # @param [String] The enum value in the form of the string
    # @return [String] The enum value
    def self.build_from_hash(value)
      new.build_from_hash(value)
    end

    # Builds the enum from string
    # @param [String] The enum value in the form of the string
    # @return [String] The enum value
    def build_from_hash(value)
      constantValues = AddressValidationDetailCode.constants.select { |c| AddressValidationDetailCode::const_get(c) == value }
      raise "Invalid ENUM value #{value} for class #AddressValidationDetailCode" if constantValues.empty?
      value
    end
  end
end
