=begin
#ShipEngine API

#ShipEngine's easy-to-use REST API lets you manage all of your shipping needs without worrying about the complexities of different carrier APIs and protocols. We handle all the heavy lifting so you can focus on providing a first-class shipping experience for your customers at the best possible prices.  Each of ShipEngine's features can be used by itself or in conjunction with each other to build powerful shipping functionality into your application or service.  ## Getting Started If you're new to REST APIs then be sure to read our [introduction to REST](https://www.shipengine.com/docs/rest/) to understand the basics. Learn how to [authenticate yourself to ShipEngine](https://www.shipengine.com/docs/auth/), and then use our [sandbox environment](https://www.shipengine.com/docs/sandbox/) to kick the tires and get familiar with our API. If you run into any problems, then be sure to check the [error handling guide](https://www.shipengine.com/docs/errors/) for tips.  Here are some step-by-step **tutorials** to get you started:    - [Learn how to create your first shipping label](https://www.shipengine.com/docs/labels/create-a-label/)   - [Calculate shipping costs and compare rates across carriers](https://www.shipengine.com/docs/rates/)   - [Track packages on-demand or in real time](https://www.shipengine.com/docs/tracking/)   - [Validate mailing addresses anywhere on Earth](https://www.shipengine.com/docs/addresses/validation/)   ## Shipping Labels for Every Major Carrier ShipEngine makes it easy to [create shipping labels for any carrier](https://www.shipengine.com/docs/labels/create-a-label/) and [download them](https://www.shipengine.com/docs/labels/downloading/) in a [variety of file formats](https://www.shipengine.com/docs/labels/formats/). You can even customize labels with your own [messages](https://www.shipengine.com/docs/labels/messages/) and [images](https://www.shipengine.com/docs/labels/branding/).   ## Real-Time Package Tracking With ShipEngine you can [get the current status of a package](https://www.shipengine.com/docs/tracking/) or [subscribe to real-time tracking updates](https://www.shipengine.com/docs/tracking/webhooks/) via webhooks. You can also create [custimized tracking pages](https://www.shipengine.com/docs/tracking/branded-tracking-page/) with your own branding so your customers will always know where their package is.   ## Compare Shipping Costs Across Carriers Make sure you ship as cost-effectively as possible by [comparing rates across carriers](https://www.shipengine.com/docs/rates/get-shipment-rates/) using the ShipEngine Rates API. Or if you don't know the full shipment details yet, then you can [get rate estimates](https://www.shipengine.com/docs/rates/estimate/) with limited address info.   ## Worldwide Address Validation ShipEngine supports [address validation](https://www.shipengine.com/docs/addresses/validation/) for virtually [every country on Earth](https://www.shipengine.com/docs/addresses/validation/countries/), including the United States, Canada, Great Britain, Australia, Germany, France, Norway, Spain, Sweden, Israel, Italy, and over 160 others. 

The version of the OpenAPI document: 1.1.202006302006
Contact: sales@shipengine.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module OpenapiClient
  class ErrorCode
    AUTO_FUND_NOT_SUPPORTED = "auto_fund_not_supported".freeze
    BATCH_CANNOT_BE_MODIFIED = "batch_cannot_be_modified".freeze
    CARRIER_CONFLICT = "carrier_conflict".freeze
    CARRIER_DISCONNECTED = "carrier_disconnected".freeze
    CARRIER_NOT_CONNECTED = "carrier_not_connected".freeze
    CARRIER_NOT_SUPPORTED = "carrier_not_supported".freeze
    CONFIRMATION_NOT_SUPPORTED = "confirmation_not_supported".freeze
    DEFAULT_WAREHOUSE_CANNOT_BE_DELETED = "default_warehouse_cannot_be_deleted".freeze
    FIELD_CONFLICT = "field_conflict".freeze
    FIELD_VALUE_REQUIRED = "field_value_required".freeze
    FORBIDDEN = "forbidden".freeze
    IDENTIFIER_CONFLICT = "identifier_conflict".freeze
    IDENTIFIERS_MUST_MATCH = "identifiers_must_match".freeze
    INVALID_ADDRESS = "invalid_address".freeze
    INVALID_BILLING_PLAN = "invalid_billing_plan".freeze
    INVALID_FIELD_VALUE = "invalid_field_value".freeze
    INVALID_IDENTIFIER = "invalid_identifier".freeze
    INVALID_STATUS = "invalid_status".freeze
    INVALID_STRING_LENGTH = "invalid_string_length".freeze
    LABEL_IMAGES_NOT_SUPPORTED = "label_images_not_supported".freeze
    METER_FAILURE = "meter_failure".freeze
    ORDER_SOURCE_NOT_ACTIVE = "order_source_not_active".freeze
    RATE_LIMIT_EXCEEDED = "rate_limit_exceeded".freeze
    REFRESH_NOT_SUPPORTED = "refresh_not_supported".freeze
    REQUEST_BODY_REQUIRED = "request_body_required".freeze
    RETURN_LABEL_NOT_SUPPORTED = "return_label_not_supported".freeze
    SETTINGS_NOT_SUPPORTED = "settings_not_supported".freeze
    SUBSCRIPTION_INACTIVE = "subscription_inactive".freeze
    TERMS_NOT_ACCEPTED = "terms_not_accepted".freeze
    TRACKING_NOT_SUPPORTED = "tracking_not_supported".freeze
    TRIAL_EXPIRED = "trial_expired".freeze
    UNAUTHORIZED = "unauthorized".freeze
    UNKNOWN = "unknown".freeze
    UNSPECIFIED = "unspecified".freeze
    VERIFICATION_FAILURE = "verification_failure".freeze
    WAREHOUSE_CONFLICT = "warehouse_conflict".freeze
    WEBHOOK_EVENT_TYPE_CONFLICT = "webhook_event_type_conflict".freeze

    # Builds the enum from string
    # @param [String] The enum value in the form of the string
    # @return [String] The enum value
    def self.build_from_hash(value)
      new.build_from_hash(value)
    end

    # Builds the enum from string
    # @param [String] The enum value in the form of the string
    # @return [String] The enum value
    def build_from_hash(value)
      constantValues = ErrorCode.constants.select { |c| ErrorCode::const_get(c) == value }
      raise "Invalid ENUM value #{value} for class #ErrorCode" if constantValues.empty?
      value
    end
  end
end
