=begin
#ShipEngine API

#ShipEngine's easy-to-use REST API lets you manage all of your shipping needs without worrying about the complexities of different carrier APIs and protocols. We handle all the heavy lifting so you can focus on providing a first-class shipping experience for your customers at the best possible prices.  Each of ShipEngine's features can be used by itself or in conjunction with each other to build powerful shipping functionality into your application or service.  ## Getting Started If you're new to REST APIs then be sure to read our [introduction to REST](https://www.shipengine.com/docs/rest/) to understand the basics. Learn how to [authenticate yourself to ShipEngine](https://www.shipengine.com/docs/auth/), and then use our [sandbox environment](https://www.shipengine.com/docs/sandbox/) to kick the tires and get familiar with our API. If you run into any problems, then be sure to check the [error handling guide](https://www.shipengine.com/docs/errors/) for tips.  Here are some step-by-step **tutorials** to get you started:    - [Learn how to create your first shipping label](https://www.shipengine.com/docs/labels/create-a-label/)   - [Calculate shipping costs and compare rates across carriers](https://www.shipengine.com/docs/rates/)   - [Track packages on-demand or in real time](https://www.shipengine.com/docs/tracking/)   - [Validate mailing addresses anywhere on Earth](https://www.shipengine.com/docs/addresses/validation/)   ## Shipping Labels for Every Major Carrier ShipEngine makes it easy to [create shipping labels for any carrier](https://www.shipengine.com/docs/labels/create-a-label/) and [download them](https://www.shipengine.com/docs/labels/downloading/) in a [variety of file formats](https://www.shipengine.com/docs/labels/formats/). You can even customize labels with your own [messages](https://www.shipengine.com/docs/labels/messages/) and [images](https://www.shipengine.com/docs/labels/branding/).   ## Real-Time Package Tracking With ShipEngine you can [get the current status of a package](https://www.shipengine.com/docs/tracking/) or [subscribe to real-time tracking updates](https://www.shipengine.com/docs/tracking/webhooks/) via webhooks. You can also create [custimized tracking pages](https://www.shipengine.com/docs/tracking/branded-tracking-page/) with your own branding so your customers will always know where their package is.   ## Compare Shipping Costs Across Carriers Make sure you ship as cost-effectively as possible by [comparing rates across carriers](https://www.shipengine.com/docs/rates/get-shipment-rates/) using the ShipEngine Rates API. Or if you don't know the full shipment details yet, then you can [get rate estimates](https://www.shipengine.com/docs/rates/estimate/) with limited address info.   ## Worldwide Address Validation ShipEngine supports [address validation](https://www.shipengine.com/docs/addresses/validation/) for virtually [every country on Earth](https://www.shipengine.com/docs/addresses/validation/countries/), including the United States, Canada, Great Britain, Australia, Germany, France, Norway, Spain, Sweden, Israel, Italy, and over 160 others. 

The version of the OpenAPI document: 1.1.202006302006
Contact: sales@shipengine.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module OpenapiClient
  class UpdateCarrierSettingsRequestBody
    # nickname
    attr_accessor :nickname

    # Indicates if the account number should be hidden on the archive documentation
    attr_accessor :should_hide_account_number_on_archive_doc

    # Indicates if this is the primary UPS account
    attr_accessor :is_primary_account

    attr_accessor :pickup_type

    attr_accessor :smart_post_hub

    attr_accessor :smart_post_endorsement

    attr_accessor :include_barcode_with_order_number

    attr_accessor :receive_email_on_manifest_processing

    # The use carbon neutral shipping program
    attr_accessor :use_carbon_neutral_shipping_program

    # The use ground freight pricing
    attr_accessor :use_ground_freight_pricing

    # The use consolidation services
    attr_accessor :use_consolidation_services

    # The use order number on mail innovations labels
    attr_accessor :use_order_number_on_mail_innovations_labels

    attr_accessor :mail_innovations_endorsement

    # mail innovations cost center
    attr_accessor :mail_innovations_cost_center

    # The use negotiated rates
    attr_accessor :use_negotiated_rates

    # account postal code
    attr_accessor :account_postal_code

    # The invoice
    attr_accessor :invoice

    # Email
    attr_accessor :email

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'nickname' => :'nickname',
        :'should_hide_account_number_on_archive_doc' => :'should_hide_account_number_on_archive_doc',
        :'is_primary_account' => :'is_primary_account',
        :'pickup_type' => :'pickup_type',
        :'smart_post_hub' => :'smart_post_hub',
        :'smart_post_endorsement' => :'smart_post_endorsement',
        :'include_barcode_with_order_number' => :'include_barcode_with_order_number',
        :'receive_email_on_manifest_processing' => :'receive_email_on_manifest_processing',
        :'use_carbon_neutral_shipping_program' => :'use_carbon_neutral_shipping_program',
        :'use_ground_freight_pricing' => :'use_ground_freight_pricing',
        :'use_consolidation_services' => :'use_consolidation_services',
        :'use_order_number_on_mail_innovations_labels' => :'use_order_number_on_mail_innovations_labels',
        :'mail_innovations_endorsement' => :'mail_innovations_endorsement',
        :'mail_innovations_cost_center' => :'mail_innovations_cost_center',
        :'use_negotiated_rates' => :'use_negotiated_rates',
        :'account_postal_code' => :'account_postal_code',
        :'invoice' => :'invoice',
        :'email' => :'email'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'nickname' => :'String',
        :'should_hide_account_number_on_archive_doc' => :'Boolean',
        :'is_primary_account' => :'Boolean',
        :'pickup_type' => :'UpsPickupType',
        :'smart_post_hub' => :'SmartPostHub',
        :'smart_post_endorsement' => :'AncillaryServiceEndorsement',
        :'include_barcode_with_order_number' => :'Boolean',
        :'receive_email_on_manifest_processing' => :'Boolean',
        :'use_carbon_neutral_shipping_program' => :'Boolean',
        :'use_ground_freight_pricing' => :'Boolean',
        :'use_consolidation_services' => :'Boolean',
        :'use_order_number_on_mail_innovations_labels' => :'Boolean',
        :'mail_innovations_endorsement' => :'AncillaryServiceEndorsement',
        :'mail_innovations_cost_center' => :'String',
        :'use_negotiated_rates' => :'Boolean',
        :'account_postal_code' => :'String',
        :'invoice' => :'UpsInvoice',
        :'email' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # List of class defined in oneOf (OpenAPI v3)
    def self.openapi_one_of
      [
      :'UpdateAmazonBuyShippingRequestBody',
      :'UpdateDhlExpressSettingsRequestBody',
      :'UpdateFedexSettingsRequestBody',
      :'UpdateNewgisticsSettingsRequestBody',
      :'UpdateUpsSettingsRequestBody'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `OpenapiClient::UpdateCarrierSettingsRequestBody` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `OpenapiClient::UpdateCarrierSettingsRequestBody`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'nickname')
        self.nickname = attributes[:'nickname']
      end

      if attributes.key?(:'should_hide_account_number_on_archive_doc')
        self.should_hide_account_number_on_archive_doc = attributes[:'should_hide_account_number_on_archive_doc']
      end

      if attributes.key?(:'is_primary_account')
        self.is_primary_account = attributes[:'is_primary_account']
      end

      if attributes.key?(:'pickup_type')
        self.pickup_type = attributes[:'pickup_type']
      end

      if attributes.key?(:'smart_post_hub')
        self.smart_post_hub = attributes[:'smart_post_hub']
      end

      if attributes.key?(:'smart_post_endorsement')
        self.smart_post_endorsement = attributes[:'smart_post_endorsement']
      end

      if attributes.key?(:'include_barcode_with_order_number')
        self.include_barcode_with_order_number = attributes[:'include_barcode_with_order_number']
      end

      if attributes.key?(:'receive_email_on_manifest_processing')
        self.receive_email_on_manifest_processing = attributes[:'receive_email_on_manifest_processing']
      end

      if attributes.key?(:'use_carbon_neutral_shipping_program')
        self.use_carbon_neutral_shipping_program = attributes[:'use_carbon_neutral_shipping_program']
      end

      if attributes.key?(:'use_ground_freight_pricing')
        self.use_ground_freight_pricing = attributes[:'use_ground_freight_pricing']
      end

      if attributes.key?(:'use_consolidation_services')
        self.use_consolidation_services = attributes[:'use_consolidation_services']
      end

      if attributes.key?(:'use_order_number_on_mail_innovations_labels')
        self.use_order_number_on_mail_innovations_labels = attributes[:'use_order_number_on_mail_innovations_labels']
      end

      if attributes.key?(:'mail_innovations_endorsement')
        self.mail_innovations_endorsement = attributes[:'mail_innovations_endorsement']
      end

      if attributes.key?(:'mail_innovations_cost_center')
        self.mail_innovations_cost_center = attributes[:'mail_innovations_cost_center']
      end

      if attributes.key?(:'use_negotiated_rates')
        self.use_negotiated_rates = attributes[:'use_negotiated_rates']
      end

      if attributes.key?(:'account_postal_code')
        self.account_postal_code = attributes[:'account_postal_code']
      end

      if attributes.key?(:'invoice')
        self.invoice = attributes[:'invoice']
      end

      if attributes.key?(:'email')
        self.email = attributes[:'email']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@nickname.nil? && @nickname.to_s.length < 1
        invalid_properties.push('invalid value for "nickname", the character length must be great than or equal to 1.')
      end

      if !@mail_innovations_cost_center.nil? && @mail_innovations_cost_center.to_s.length < 0
        invalid_properties.push('invalid value for "mail_innovations_cost_center", the character length must be great than or equal to 0.')
      end

      if !@account_postal_code.nil? && @account_postal_code.to_s.length < 5
        invalid_properties.push('invalid value for "account_postal_code", the character length must be great than or equal to 5.')
      end

      if !@email.nil? && @email.to_s.length < 1
        invalid_properties.push('invalid value for "email", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@nickname.nil? && @nickname.to_s.length < 1
      return false if !@mail_innovations_cost_center.nil? && @mail_innovations_cost_center.to_s.length < 0
      return false if !@account_postal_code.nil? && @account_postal_code.to_s.length < 5
      return false if !@email.nil? && @email.to_s.length < 1
      _one_of_found = false
      self.class.openapi_one_of.each do |_class|
        _one_of = OpenapiClient.const_get(_class).build_from_hash(self.to_hash)
        if _one_of.valid?
          if _one_of_found
            return false
          else
            _one_of_found = true
          end
        end
      end

      if !_one_of_found
        return false
      end

      true
    end

    # Custom attribute writer method with validation
    # @param [Object] nickname Value to be assigned
    def nickname=(nickname)
      if !nickname.nil? && nickname.to_s.length < 1
        fail ArgumentError, 'invalid value for "nickname", the character length must be great than or equal to 1.'
      end

      @nickname = nickname
    end

    # Custom attribute writer method with validation
    # @param [Object] mail_innovations_cost_center Value to be assigned
    def mail_innovations_cost_center=(mail_innovations_cost_center)
      if !mail_innovations_cost_center.nil? && mail_innovations_cost_center.to_s.length < 0
        fail ArgumentError, 'invalid value for "mail_innovations_cost_center", the character length must be great than or equal to 0.'
      end

      @mail_innovations_cost_center = mail_innovations_cost_center
    end

    # Custom attribute writer method with validation
    # @param [Object] account_postal_code Value to be assigned
    def account_postal_code=(account_postal_code)
      if !account_postal_code.nil? && account_postal_code.to_s.length < 5
        fail ArgumentError, 'invalid value for "account_postal_code", the character length must be great than or equal to 5.'
      end

      @account_postal_code = account_postal_code
    end

    # Custom attribute writer method with validation
    # @param [Object] email Value to be assigned
    def email=(email)
      if !email.nil? && email.to_s.length < 1
        fail ArgumentError, 'invalid value for "email", the character length must be great than or equal to 1.'
      end

      @email = email
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          nickname == o.nickname &&
          should_hide_account_number_on_archive_doc == o.should_hide_account_number_on_archive_doc &&
          is_primary_account == o.is_primary_account &&
          pickup_type == o.pickup_type &&
          smart_post_hub == o.smart_post_hub &&
          smart_post_endorsement == o.smart_post_endorsement &&
          include_barcode_with_order_number == o.include_barcode_with_order_number &&
          receive_email_on_manifest_processing == o.receive_email_on_manifest_processing &&
          use_carbon_neutral_shipping_program == o.use_carbon_neutral_shipping_program &&
          use_ground_freight_pricing == o.use_ground_freight_pricing &&
          use_consolidation_services == o.use_consolidation_services &&
          use_order_number_on_mail_innovations_labels == o.use_order_number_on_mail_innovations_labels &&
          mail_innovations_endorsement == o.mail_innovations_endorsement &&
          mail_innovations_cost_center == o.mail_innovations_cost_center &&
          use_negotiated_rates == o.use_negotiated_rates &&
          account_postal_code == o.account_postal_code &&
          invoice == o.invoice &&
          email == o.email
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [nickname, should_hide_account_number_on_archive_doc, is_primary_account, pickup_type, smart_post_hub, smart_post_endorsement, include_barcode_with_order_number, receive_email_on_manifest_processing, use_carbon_neutral_shipping_program, use_ground_freight_pricing, use_consolidation_services, use_order_number_on_mail_innovations_labels, mail_innovations_endorsement, mail_innovations_cost_center, use_negotiated_rates, account_postal_code, invoice, email].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        OpenapiClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
